package cn.com.tenlion.systembase.util.fullsync;

import cn.com.tenlion.systembase.pojo.dtos.keyplace.KeyPlaceDTO;
import cn.com.tenlion.systembase.pojo.dtos.keyplacepatrol.KeyPlacePatrolDTO;
import cn.com.tenlion.systembase.pojo.vos.keyplacepatrol.KeyPlacePatrolVO;
import cn.com.tenlion.systembase.service.keyplace.IKeyPlaceService;
import cn.com.tenlion.systembase.service.keyplacepatrol.IKeyPlacePatrolService;
import com.alibaba.fastjson.JSONObject;
import ink.wgink.exceptions.SearchException;
import ink.wgink.util.map.HashMapUtil;
import org.apache.kafka.clients.consumer.ConsumerRecord;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.ApplicationEventPublisher;
import org.springframework.context.ApplicationEventPublisherAware;
import org.springframework.kafka.annotation.KafkaListener;
import org.springframework.kafka.core.KafkaTemplate;
import org.springframework.stereotype.Component;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * 表单全量数据同步
 * 接收数据整合系统发来的全量数据同步命令, 向数据整合系统发送表单的全部数据
 */
@Component
public class FullSyncC0020 implements ApplicationEventPublisherAware {

    private ApplicationEventPublisher applicationEventPublisher;
    @Autowired
    private IKeyPlacePatrolService keyPlacePatrolService;
    @Autowired
    private IKeyPlaceService keyPlaceService;
    @Autowired
    KafkaTemplate kafkaTemplate;

    public FullSyncC0020() {}

    @KafkaListener(topics = "C0020FullSync")
    public void message(ConsumerRecord<?, ?> record) {
        System.out.println("收到全量同步命令");
        JSONObject jsonObject = JSONObject.parseObject(record.value().toString());
        System.out.println(jsonObject.toJSONString());// 表单编号
        System.out.println(jsonObject.getString("tableNumber"));// 表单编号
        System.out.println(jsonObject.getInteger("tableDataCount"));// 整合系统数据量
        /**
         * 1 . 查询本地数据的数量 , 如果本地数据量 > 整合系统数据量
         * 2 . 查询数据库中所有的事件列表
         * 3 . 遍历事件, 封装数据
         * 4 . 发送新增案件消息
         */
        Map<String, Object> params = new HashMap<>();
        List<KeyPlacePatrolDTO> keyPlacePatrolDTOList = keyPlacePatrolService.list(params);
        System.out.println(keyPlacePatrolDTOList.size());
        if(null != keyPlacePatrolDTOList && keyPlacePatrolDTOList.size() > 0) {
            for(KeyPlacePatrolDTO keyPlacePatrolDTO: keyPlacePatrolDTOList) {
                params = HashMapUtil.beanToMap(keyPlacePatrolDTO);
                System.out.println("keyPlacePatrolDTO.getKeyPlaceId() = " + keyPlacePatrolDTO.getKeyPlaceId());
                KeyPlaceDTO keyPlaceDTO = keyPlaceService.get(keyPlacePatrolDTO.getKeyPlaceId());
                KeyPlacePatrolVO keyPlacePatrolVO = setData(keyPlacePatrolDTO, keyPlaceDTO);
                String creator = keyPlacePatrolService.getUserData(params, keyPlacePatrolVO);
                keyPlacePatrolService.saveKafka(keyPlacePatrolDTO.getKeyPlacePatrolId(), keyPlacePatrolVO, creator, keyPlaceDTO);
            }
        }
    }

    @KafkaListener(topics = "C0020")
    public void messageMsg(ConsumerRecord<?, ?> record) {
        JSONObject jsonObject = JSONObject.parseObject(record.value().toString());
        Map<String, Object> params;
        if(!"delete".equals(jsonObject.getString("action"))) {
            KeyPlacePatrolDTO keyPlacePatrolDTO = keyPlacePatrolService.get(jsonObject.getString("uid"));
            params = HashMapUtil.beanToMap(keyPlacePatrolDTO);
            KeyPlaceDTO keyPlaceDTO = keyPlaceService.get(keyPlacePatrolDTO.getKeyPlaceId());
            KeyPlacePatrolVO keyPlacePatrolVO = setData(keyPlacePatrolDTO, keyPlaceDTO);
            String creator = keyPlacePatrolService.getUserData(params, keyPlacePatrolVO);
            keyPlacePatrolService.saveKafka(keyPlacePatrolDTO.getKeyPlacePatrolId(), keyPlacePatrolVO, creator, keyPlaceDTO);

        }else {
            keyPlacePatrolService.deleteKafka(jsonObject.getString("uid"));
        }
    }

    private KeyPlacePatrolVO setData(KeyPlacePatrolDTO keyPlacePatrolDTO, KeyPlaceDTO keyPlaceDTO) {
        if(null == keyPlacePatrolDTO) {
            throw new SearchException("当前对象为空,请注意查看");
        }
        if(null == keyPlaceDTO) {
            throw new SearchException("当前对象为空,请注意查看");
        }
        KeyPlacePatrolVO keyPlacePatrolVO = new KeyPlacePatrolVO();
        keyPlacePatrolVO.setKeyPlaceId(keyPlaceDTO.getKeyPlaceId());
        keyPlacePatrolVO.setKeyPlaceName(keyPlaceDTO.getPlaceName());
        keyPlacePatrolVO.setPatrolTime(keyPlacePatrolDTO.getPatrolTime());
        return keyPlacePatrolVO;
    }

    @Override
    public void setApplicationEventPublisher(ApplicationEventPublisher applicationEventPublisher) {
        this.applicationEventPublisher = applicationEventPublisher;
    }

}